`default_nettype none
module topLX9(data, lrck, bck, rot, notSevenofNine, notapodizing, dsdviasd, mute, sdclockin, yl, yr, iclip, scale, dsdon, bckout, dsd_out);

input wire rot, notSevenofNine, mute, notapodizing;
(* CLOCK_SIGNAL = "TRUE" *) input wire sdclockin;
(* CLOCK_SIGNAL = "TRUE" *) input wire bck;

input wire data, lrck;
input wire dsdon, dsdviasd;
input wire [1:0] scale;
output reg yl, yr;
output wire bckout, iclip, dsd_out;

(* CLOCK_SIGNAL = "TRUE" *) wire sdclockbufio2;
(* CLOCK_SIGNAL = "TRUE" *) wire sdclock;
(* CLOCK_SIGNAL = "TRUE" *) wire sdclockinbb;

reg norot_synch = 1'b0;
reg SevenofNine_synch = 1'b0;
reg mute_synch = 1'b0;
reg apodizing_synch = 1'b0;
reg dsdon_synch = 1'b0;
reg dsdviasd_synch = 1'b0;
wire interpolneeded, dsdfiltneeded, sdneeded;

wire yl_int, yr_int;
reg yl_int2, yr_int2;
wire [42:0] rnd1;
wire signed [42:0] rnd2;
wire [2:0] rotl;
wire [2:0] rotr;
wire [17:0] dummy1;
wire [17:0] dummy2;
wire [9:0] dummy3;
wire iclipl, iclipr;
reg [24:0] iclipstretch;
(* CLOCK_SIGNAL = "TRUE" *) wire sdclock5;
wire signed [26:0] rnd3;
wire signed [26:0] rnd4;

wire signed [31:0] x;
reg signed [34:0] xl = 35'b0;
reg signed [34:0] xr = 35'b0;
reg signed [34:0] xlp0 = 35'b0;
reg signed [34:0] xlp = 35'b0;
reg signed [34:0] xrp = 35'b0;
reg signed [34:0] xlpp = 35'b0;
reg signed [34:0] xrpp = 35'b0;
wire full, empty;
wire [63:0] doutfifo;
reg [14:0] teller = 15'b0;
reg [14:0] meas = 15'b0;
reg [8:0] meas64;
reg [10:0] teller2 = 11'b0;
reg read = 1'b0;
reg read2 = 1'b0;

reg lr3 = 1'b0;
reg lr5 = 1'b0;
(* ASYNC_REG = "TRUE" *) reg lr4 = 1'b0;
(* ASYNC_REG = "TRUE" *) reg lrckds = 1'b0;
wire lr2;
reg lrup, lrdown;
wire nd;
wire rfd;
wire rdy, chan_in, chan_out;
wire signed [61:0] doutfilt;

(* ASYNC_REG = "TRUE" *) reg [5:0] synch1 = 6'b000000;
(* ASYNC_REG = "TRUE" *) reg [5:0] synch2 = 6'b000000;

wire endofstartup, reset0, reset1, reset2, resetpll, reset1sdc, reset2sdc, reset;
wire filterreset1, filterreset;

wire datasynch, lrcksynch, bcksynch, tel0;
reg lrcksynchd, datasynchd;
reg lrcksynch2, datasynch2;

wire signed [11:0] outdsdfl;
wire signed [11:0] outdsdfr;

wire norot, SevenofNine, apodizing;

PULLDOWN pd1(mute);
PULLDOWN pd2(dsdon);
PULLDOWN pd3(scale[1]);
PULLUP pu1(dsdviasd);
PULLUP pu2(notSevenofNine);
PULLUP pu3(rot);
PULLUP pu4(notapodizing);
PULLUP pu5(scale[0]);

assign norot = !rot;
assign SevenofNine = !notSevenofNine;
assign apodizing = !notapodizing;

assign dsd_out = 1'b1; // voor uitwisselbaarheid met PCM2DSD, for compatibility with PCM2DSD

// Opwekken algehele reset
// Generating the overall reset

STARTUP_SPARTAN6 startding(.EOS(endofstartup), .CLK(1'b0), .GSR(1'b0), .GTS(1'b0), .KEYCLEARB(1'b1));

assign reset0 = !endofstartup;
// FDPE bla (output, clock, clock enable, asynchronous preset, data);
(* ASYNC_REG = "TRUE" *) FDPE flipflop1(reset1, sdclockinbb, 1'b1, reset0, reset0);
(* ASYNC_REG = "TRUE" *) FDPE flipflop2(reset2, sdclockinbb, 1'b1, reset1, reset1);
(* ASYNC_REG = "TRUE" *) FDPE flipflop3(resetpll, sdclockinbb, 1'b1, reset2, reset2);
// Reset voor PLL verlengd tot er in ieder geval een externe klok beschikbaar is.
// Reset for PLL stretched until an external clock is available.

(* ASYNC_REG = "TRUE" *) FDPE flipflop4(reset1sdc, sdclock, LOCKED, reset0, reset0);
(* ASYNC_REG = "TRUE" *) FDPE flipflop5(reset2sdc, sdclock, LOCKED, reset1sdc, reset1sdc);
(* ASYNC_REG = "TRUE" *) FDPE flipflop6(reset, sdclock, 1'b1, reset2sdc, reset2sdc);
// Reset voor de rest gesynchroniseerd met de klokken die uit de PLL komen, reset kan pas omlaag nadat PLL vergrendeld is.
// Reset for everything else synchronized with the clocks coming from the PLL, reset can only be deactivated once the PLL is locked.

FDPE flipflop7(filterreset1, sdclock5, 1'b1, (reset || (!interpolneeded)), (reset || (!interpolneeded)));
FDPE flipflop8(filterreset, sdclock5, 1'b1, filterreset1, filterreset1);

reg bckoutp1, bckoutp2;

always @ (posedge sdclock)
begin
	if (sdneeded)
		bckoutp1 <= 1'b0;
	else
		bckoutp1 <= !bcksynch;
end
always @ (negedge sdclock)
begin
	if (sdneeded)
		bckoutp2 <= 1'b1;
	else
		bckoutp2 <= !bcksynch;
end

ODDR2 #(
	.DDR_ALIGNMENT("NONE"),
	.INIT(1'b0),
	.SRTYPE("SYNC")
) ODDR2_bckout (
	.Q(bckout),
	.C0(sdclockinbb),
	.C1(!sdclockinbb),
	.CE(1'b1),
	.D0(bckoutp2),
	.D1(bckoutp1),
	.R(1'b0),
	.S(1'b0)
);

always @ (posedge sdclock)
begin
	synch1 <= {norot, SevenofNine, (mute || (!LOCKED)), apodizing, dsdon, dsdviasd};
		// mute || (!LOCKED) als poging de uitgangen stil te maken wanneer de PLL ontgrendeld raakt
		// mute || (!LOCKED) as an attempt to mute the outputs when the PLL gets unlocked
	synch2 <= synch1;
	{norot_synch, SevenofNine_synch, mute_synch, apodizing_synch, dsdon_synch, dsdviasd_synch} <= synch2;
end

assign interpolneeded = !dsdon_synch;
assign dsdfiltneeded = dsdon_synch && dsdviasd_synch;
assign sdneeded = !(dsdon_synch && (!dsdviasd_synch));

// Poging tot pijpleidingerij, attempt at pipelining
reg [42:0] rnd1l = 43'b0;
reg signed [42:0] rnd2l = 43'sb0;
reg [42:0] rnd1r = 43'b0;
reg signed [42:0] rnd2r = 43'sb0;
always @ (posedge sdclock5)
begin
	rnd1l <= rnd1;
	rnd2l <= rnd2;
	rnd1r <= ~rnd1;
	rnd2r <= rnd2;
end

sigmadelta sdl(xl, norot_synch, SevenofNine_synch, sdclock, sdclock5, rnd1l, rnd2l, rotl, yl_int, iclipl, scale, sdneeded);
sigmadelta sdr(xr, norot_synch, SevenofNine_synch, sdclock, sdclock5, rnd1r, rnd2r, rotr, yr_int, iclipr, scale, sdneeded);

always @ (posedge sdclock)
begin
	if (!mute_synch)
	begin
		yl_int2 <= yl_int; // pijpleidingerij, pipelining
		yr_int2 <= yr_int;
	end
	else
	begin
		yl_int2 <= !yl_int2; // stilte, dus 10101010... 
		yr_int2 <= !yr_int2; // silence, so 10101010...
	end
	datasynch2 <= datasynch;
	lrcksynch2 <= lrcksynch;
end
always @ (negedge sdclockinbb)
begin
	if (sdneeded)
	begin	
		yl <= yl_int2;
		yr <= yr_int2;
	end
	else
	begin
		yl <= datasynch2; // Amanero-conventie: I2S_DATa/DSDL en I2S_FSCL/DSDR
		yr <= lrcksynch2; // Amanero convention: I2S_DATa/DSDL and I2S_FSCL/DSDR
	end
end

always @ (posedge sdclock)
begin
	if ((!sdneeded) || reset)
	begin
		iclipstretch = 25'h1000000;
	end
	else 
	begin
		if (iclipl || iclipr)
			iclipstretch = 25'h0000000;
		else
			if (iclipstretch != 25'h1000000) iclipstretch = iclipstretch + 25'h0000001;
	end
end
assign iclip = !iclipstretch[24];

xorshiftplus xspl1(sdclock5, (reset || (!sdneeded)), {64'h45830FC02AB7040E}, {rotr, rnd1, dummy1});
xorshiftplus xspl2(sdclock5, (reset || (!sdneeded)), {64'h93205FF30FF98110}, {rotl, rnd2, dummy2});
xorshiftplus xspl3(sdclock5, (reset || (!sdneeded)), {64'hF023F65E2AB78877}, {rnd3[26], rnd4[26], rnd3[25], rnd4[25], rnd3[24], rnd4[24], rnd3[23], rnd4[23], rnd3[22], rnd4[22], rnd3[21], rnd4[21], rnd3[20], rnd4[20], rnd3[19:0], rnd4[19:0], dummy3}); 

// PLL VCO-frequentie: 400 MHz tot 1000 MHz (-2) of 1080 MHz (-3), zie DS162
// PLL-bandbreedte: smal 1 MHz typ., breed 4 MHz typ.
// 20 keer 20 tot 25 MHz is 400 MHz tot 500 MHz

wire CLKFBOUT, sdclockio, CLKOUT0, CLKOUT1, CLKOUT2, CLKOUT3, CLKOUT4, CLKOUT5, LOCKED, fbclock5, SERDESSTROBE, sdclockibuf;

// PLL_BASE: Phase Locked Loop (PLL) Clock Management Component
// Spartan-6
// Xilinx HDL Libraries Guide, version 14.7
PLL_BASE #(
	.BANDWIDTH("LOW"), // "HIGH", "LOW" or "OPTIMIZED". LOW voor minimale verstoring bij omschakelen externe klok.
	.CLKFBOUT_MULT(5), // Apparently the feedback divider division ratio (1-64), feedback from CLKOUT0 because of the CLK_FEEDBACK
	.CLKFBOUT_PHASE(0.0), // Phase offset in degrees of the clock feedback output (0.0-360.0).
	.CLKIN_PERIOD(40), // Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
	// CLKOUT0_DIVIDE - CLKOUT5_DIVIDE: division ratio between VCO and outputs (1-128)
	.CLKOUT0_DIVIDE(4),
	.CLKOUT1_DIVIDE(20),
	.CLKOUT2_DIVIDE(4),
	.CLKOUT3_DIVIDE(4),
	.CLKOUT4_DIVIDE(4),
	.CLKOUT5_DIVIDE(4),
	// CLKOUT0_DUTY_CYCLE - CLKOUT5_DUTY_CYCLE: Duty cycle for CLKOUT# clock output (0.01-0.99).
	.CLKOUT0_DUTY_CYCLE(0.5),
	.CLKOUT1_DUTY_CYCLE(0.5),
	.CLKOUT2_DUTY_CYCLE(0.5),
	.CLKOUT3_DUTY_CYCLE(0.5),
	.CLKOUT4_DUTY_CYCLE(0.5),
	.CLKOUT5_DUTY_CYCLE(0.5),
	// CLKOUT0_PHASE - CLKOUT5_PHASE: Output phase relationship for CLKOUT# clock output (-360.0-360.0).
	.CLKOUT0_PHASE(0.0),
	.CLKOUT1_PHASE(0.0),
	.CLKOUT2_PHASE(0.0),
	.CLKOUT3_PHASE(0.0),
	.CLKOUT4_PHASE(0.0),
	.CLKOUT5_PHASE(0.0),
	.CLK_FEEDBACK("CLKOUT0"), // Clock source to drive CLKFBIN ("CLKFBOUT" or "CLKOUT0")
	.COMPENSATION("SYSTEM_SYNCHRONOUS"), // "SYSTEM_SYNCHRONOUS", "SOURCE_SYNCHRONOUS", "EXTERNAL"
	.DIVCLK_DIVIDE(1), // Reference divider division ratio (1-52)
	.REF_JITTER(0.002), // Reference Clock Jitter in UI (0.000-0.999).
	.RESET_ON_LOSS_OF_LOCK("FALSE") // Must be set to FALSE
)
PLL_BASE_inst (
	.CLKFBOUT(CLKFBOUT), // 1-bit output: PLL_BASE feedback output
	// CLKOUT0 - CLKOUT5: 1-bit (each) output: Clock outputs
	.CLKOUT0(CLKOUT0),
	.CLKOUT1(CLKOUT1),
	.CLKOUT2(CLKOUT2),
	.CLKOUT3(CLKOUT3),
	.CLKOUT4(CLKOUT4),
	.CLKOUT5(CLKOUT5),
	.LOCKED(LOCKED), // 1-bit output: PLL_BASE lock status output
	.CLKFBIN(fbclock5), // 1-bit input: Feedback clock input
	.CLKIN(sdclockbufio2), // 1-bit input: Clock input
	.RST(resetpll) // 1-bit input: Reset input
);
// End of PLL_BASE_inst instantiation

BUFG BUFG_inst5 (
.O(sdclock5), // 1-bit output: Clock buffer output
.I(CLKOUT0) // 1-bit input: Clock buffer input
);

BUFG BUFG_inst1 (
.O(sdclock), // 1-bit output: Clock buffer output
.I(CLKOUT1) // 1-bit input: Clock buffer input
);

IBUFG IBUFG_sdclock (.O(sdclockibuf), .I(sdclockin));

BUFIO2FB #(
.DIVIDE_BYPASS("TRUE") // Bypass divider (TRUE/FALSE)
)
BUFIO2FB_inst (
.O(fbclock5), // 1-bit output: Output feedback clock (connect to feedback input of DCM/PLL)
.I(CLKOUT0) // 1-bit input: Feedback clock input (connect to input port)
);

// BUFIO2: I/O Clock Buffer Spartan-6 
// Xilinx HDL Libraries Guide, version 14.7
BUFIO2 #(
.DIVIDE(1), // DIVCLK divider (1,3-8)
.DIVIDE_BYPASS("TRUE"), // Bypass the divider circuitry (TRUE/FALSE)
.I_INVERT("FALSE"), // Invert clock (TRUE/FALSE)
.USE_DOUBLER("FALSE") // Use doubler circuitry (TRUE/FALSE)
)
BUFIO2_inst (
.DIVCLK(sdclockbufio2),
// output that can drive a PLL
.IOCLK(sdclockio),
// 1-bit output: I/O output clock
.SERDESSTROBE(SERDESSTROBE), // 1-bit output: Output SERDES strobe (connect to ISERDES2/OSERDES2)
.I(sdclockibuf)
// 1-bit input: Clock input (connect to IBUFG)
);
// End of BUFIO2_inst instantiation

BUFG BUFG_instn (
.O(sdclockinbb), // 1-bit output: Clock buffer output
.I(sdclockibuf) // 1-bit input: Clock buffer input
);

// wire sdclockinvdummy, sdclockinvio, SERDESSTROBE2;

// BUFIO2 #(
// .DIVIDE(1), // DIVCLK divider (1,3-8)
// .DIVIDE_BYPASS("TRUE"), // Bypass the divider circuitry (TRUE/FALSE)
// .I_INVERT("TRUE"), // Invert clock (TRUE/FALSE)
// .USE_DOUBLER("FALSE") // Use doubler circuitry (TRUE/FALSE)
// )
// BUFIO2_inverted (
// .DIVCLK(sdclockinvdummy),
// // output that can drive a PLL
// .IOCLK(sdclockinvio),
// // 1-bit output: I/O output clock
// .SERDESSTROBE(SERDESSTROBE2), // 1-bit output: Output SERDES strobe (connect to ISERDES2/OSERDES2)
// .I(sdclockibuf)
// // 1-bit input: Clock input (connect to IBUFG)
// );

i2ssdclocksynch i2ssdclocksynch1(data, lrck, bck, sdclock, sdclock5, datasynch, lrcksynch, bcksynch, tel0);

// I2S-ingangsinterface, zoals in de buizen-DAC, en wat logica om het te synchroniseren
// met een ander klokdomein, ook zoals in de buizen-DAC. Er wordt gebruik gemaakt van
// het feit dat er veel klokcycli zijn tussen twee ingangsmonsters.
// De synchronisatielogica zou overtollig moeten zijn nu er een i2ssdclocksycnh is.
// data, bck en lrck zijn I2S-ingangssignalen, x en lr2 uitgangssignalen van de interface die i2s of i2sin heet

// I2S input interface, like in the valve DAC, and some logic to synchronize it
// to another clock domain, also taken from the valve DAC. It is taking advantage
// of the fact that there are many clock cycles in between input samples.
// The synchronization logic should be superfluous now there is an i2ssdclocksynch.
// data, bck and lrck are I2S input signals, x and lr2 output signals of the interface called i2s or i2sin

// i2s i2sin(x, lr2, data, bck, lrck);
//
// bcksynch is netjes afgeklokt en zou dus spijkervrij moeten zijn.
// bcksynch wordt op dezelfde sdclock5-flank veranderd als datasynch en
// lrcksynch, maar kennelijk haal je dan toch de timing, inclusief houdtijd.
// Desalniettemin heb ik er toch nog een register tussen gehangen.
// bcksynch comes straight from a flip-flop and should be free of spikes.
// bcksynch us changed in the same sdclock5 edge as datasynch and lrcksynch,
// but apparently timing is then met, als the hold time.
// Nonetheless I put a register in between.
always @ (posedge sdclock5)
begin
	lrcksynchd <= lrcksynch;
	datasynchd <= datasynch;
end

i2s i2sin(x, lr2, datasynchd, bcksynch, lrcksynchd);
always @ (posedge bcksynch)
begin
	lr3 <= lr2;
end
always @ (posedge sdclock5)
begin
	lr4 <= lr3;
	lrckds <= lr4;
	lr5 <= lrckds;
end
always @ *
begin
	lrup = lrckds & (~lr5);
	lrdown = lr5 & (~lrckds);
end

assign nd = (chan_in ? lrup : lrdown) && (!filterreset);

interpol8 interpolator (
	.sclr(filterreset), // input sclr
	.clk(sdclock5), // input clk
	.ce(interpolneeded), // input ce
	.nd(nd), // input nd
	.filter_sel(apodizing_synch), // filter coefficient selection
	.rfd(rfd), // output rfd
	.rdy(rdy), // output rdy
	.chan_in(chan_in), // output [0 : 0] chan_in
	.chan_out(chan_out), // output [0 : 0] chan_out
	.din(x), // input [31 : 0] din
	.dout(doutfilt)); // output [61 : 0] dout


fifo_32w_64b fifo64 (
  .clk(sdclock5), // input clk
  .din({chan_out, 1'b0, doutfilt[61:0]}), // input [63 : 0] din
  .wr_en(rdy && (!full)), // input wr_en
  .rd_en(read && (!empty)), // input rd_en
  .dout(doutfifo), // output [63 : 0] dout
  .full(full), // output full
  .empty(empty) // output empty
);

// logica om de geinterpoleerde data equidistant uit te lezen, de
// sdclockfrequentie moet een geheel aantal keer 64 keer de lrck-frequentie zijn
// logic to read out the interpolated data equidistantly, the sdclock
// frequency must be an integer times 64 times the lrck frequency
always @ (posedge sdclock5)
begin
	if (reset || lrdown) // down of up? lrdown en -up draaien op sdclock5, dus dan dit ook maar.
	begin
		meas <= teller;
		teller <= 15'b0;
	end
	else
		teller <= (teller + 15'b1) % 32768;
end
always @ (*)
begin
	meas64 = (meas + 15'd32) >> 6;
end
always @ (posedge sdclock5)
begin
	if (reset || (teller2 == {meas64, 2'b00})) // gebeurt 2^6/4 = 16 keer per lrck-periode, 8 voor links, 8 voor rechts
						// happens 2^6/4 = 16 times per lrck-period, 8 for left, 8 for right
	begin
		teller2 <= 11'b0;
		read <= 1'b1; // pogingen om FIFO te lezen tijdens reset worden toch geblokkeerd
	end
	else
	begin
		teller2 <= (teller2 + 11'b1) % 2048;
		read <= 1'b0;
	end
	read2 <= read;
	if ((read2) && (doutfifo[63] == 1'b0)) xlp0 <= (($signed(doutfifo[61:0]) + rnd3 + rnd4) >>> 27);
	if ((read2) && (doutfifo[63] == 1'b1)) 
	begin
		xrp <= (($signed(doutfifo[61:0]) + rnd3 + rnd4) >>> 27);
		xlp <= xlp0;
		// Klopt dit nou of zit ik er een klokperiode naast of doe ik links en rechts verkeerdom?
		// Links en rechts kennelijk niet verkeerdom, zo blijkt uit simulaties.
		// Volgorde I2S is links-rechts; rechts en de daarvoor
		// doorgegeven links moeten worden ingeklokt als rechts klaar
		// is. Net als hier dus.
	end
	if (dsdon_synch && dsdviasd_synch)
	begin
		xlpp <= $signed({outdsdfl, 23'b0});
		xrpp <= $signed({outdsdfr, 23'b0});
	end
	else
	begin
		xlpp <= xlp;
		xrpp <= xrp;
	end
	if (sdneeded)
	begin
		xl <= xlpp;
		xr <= xrpp;
	end
	else
	begin
		xl <= 35'sb0;
		xr <= 35'sb0;
	end
end

dsdfirlr dsdfirlr1(outdsdfl, outdsdfr, datasynch, lrcksynch, bcksynch, sdclock5, dsdfiltneeded);

endmodule
`default_nettype wire
